% !TeX spellcheck = en_GB

Another approach of analysing the scatter result is the usage of deep neuronal networks. They have some advantages over classical machine learning models like \gls{SVM}s, for example the ability to directly learn pattern and features from the data and also their theoretical better ability to generalize data. Their main drawback is the explainabiliy of their performance, which will be further analysed in each subsection.


\subsection{Basic approach}
\begin{itemize}
	\item mention that always tracking test accuracy during training the model
    \item talk about optimizer and loss functions
\end{itemize}


\subsection{Multilayer perceptron}
\label{ssec:mlp}
As a first neuronal network for classification the scattering transform coefficients are fed into a \gls{MLP}. A \gls{MLP} is a fully connected feedforward neuronal network, meaning each neuron is connected with each other, and the data flows from input to the output layer. The classification is done in the output layer, which contains as many neurons as classes to be classified. Each connection between the neurons has a specific weight and a bias which value is updated during the learning phase to reduce the loss of the model.\footnote{\url{https://www.sciencedirect.com/topics/computer-science/multilayer-perceptron}}.

% TODO: mention Perceptron and activation function after each perceptron

The implementation can be found in the file \textbf{scattering\_sequential\_single\_channel\_mean\_mlp.ipynb}. The activation function for the hidden layers is the rectified linear unit (ReLU), which is defined as:
$$
f(x) = max(0, x)
$$
The output layer uses the log softmax activation function, which is used for multi-class classification. The log softmax function is defined as:
$$
\log(\sigma(z)_j) = \frac{z_j - \log(\sum_{k=1}^{K} e^{z_k})}{\log(2)}
$$

where $z$ is the input to the output layer and $K$ is the number of classes. The output of the softmax function is a probability distribution over the classes, meaning the sum of all output values is 1. The class with the highest probability is then used as the predicted class.

For this analysis only channel 3 of the ecg signals is used, which had the highest accuracy in the previous analysis.

The model is trained using the Adam optimizer and the categorical crossentropy loss function. The Adam optimizer is an extension of the stochastic gradient descent and is used for updating the weights of the model. The categorical crossentropy loss function is used for multi-class classification and is defined as:
$$
H(y, \hat{y}) = - \sum_{i=1}^{n} y_i \cdot \log(\hat{y}_i)
$$
where $y$ is the true label and $\hat{y}$ is the predicted label. The loss function is used to measure the difference between the true and the predicted label. The goal of the training is to minimize the loss function, meaning the predicted label should be as close as possible to the true label.

Because the dataset itself is imbalanced, the data loader function is adjusted to load the same number of samples for each class.

For a first analysis a linear model with 1 hidden layer with 128 neurons is used. The accuracy results for the train and test set are shown in figure \ref{img:linear_model_accuracies_233_128_2}, with a best test accuracy of only 0.585. For the validation set the accuracy was also only 0.6. Adding additional layer or more neurons did not improve the accuracy.

\begin{figure}[H]
	\centering
	\includegraphics[width=0.8\textwidth]{images/linear_model_accuracies_233_128_2.png}
	\caption{}
	\label{img:linear_model_accuracies_233_128_2}
\end{figure}



\subsection{Convolutional Neural Network}
An alternative way for analysing the scattering transform results is a \gls{CNN}. A \gls{CNN} is a type of neuronal network which is mostly used for image recognition and classification. The main difference to a \gls{MLP} is the usage of convolutional layers, which are used for extracting features from the input data. This is done by concolving filter over the input data. Those filters are specified by the kernel size, for example in a Conv1D layer a kernel size of 3 results in each filter containing 3 floating point numbers. The filter is then slided over the input data and the dot product of the filter and the input data is calculated. The weight value itself is comparable to the weights of \gls{MLP} and is updated during the learning phase. 1D \gls{CNN}s can be seen as a state-of-the-art method for signal processing applications, among others for \gls{ECG} classification.\footnote{\url{https://www.sciencedirect.com/science/article/pii/S0888327020307846}}

After a convolutional layer an activation function followed by a pooling layer is used. The pooling layer allows extracting the most important features by applying for example a max pooling, where the max value inside the specific kernel size is used. Furthermore, the pooling layer reduces the dimensionality of the data, which allows reducing the computational complexity of the model.

For analysing the scattering transform coefficients, a \gls{CNN} with multiple Conv1D layers with ReLU activation function and max pooling layers is used. The output of the last pooling layer is then flattened and fed into a \gls{MLP}. In contrast to section \ref{ssec:mlp}, all \gls{ECG} channels are used for the analysis.

The result of the \gls{CNN} model is shown in figure \ref{img:accuracy_cnn_model}. The best test accuracy is still only 0.54 showing that this model is also not able of classifying the \gls{ECG} signals correctly.

\begin{figure}[H]
	\centering
	\includegraphics[width=0.8\textwidth]{images/accuracy_cnn_model.png}
	\caption{}
	\label{img:accuracy_cnn_model}
\end{figure}



\subsection{Long Short-Term Memory Network}
As a final approach for analysing the scattering coefficients using neuronal network a \gls{LSTM} is choosen. They belong to the \gls{RNN} architecture with the advantage of being able to capture long-term dependencies in time series. This is done by using a internal, hidden state to store information over time.


% scattering_sequential_singlechannel_timeseries_lstm.ipynb




\begin{figure}[H]
	\centering
	\includegraphics[width=0.8\textwidth]{images/lstm_accuracies.png}
	\caption{}
	\label{img:lstm_accuracies}
\end{figure}